/* yasep/core-js/yasep_forms.js
created 2006-08-10 by whygee@f-cpu.org
2006-08-12
2006-09-02 : moved to vspsim/JScore/
2007-04-01 : added FORM_RI
2007-04-05 : added the jmp/skip related forms
2007-04-08 : cleanup
2007-04-09 : moved elements from JSgui/decoration.js
   to keep symbols in sync, moving the flags to vsp_flags.js
2007-11-05 : rebranding to YASEP, added support for flags IMM16_5LSB and IMM16_8LSB
2009-07-15 : cleanup for the current architecure
2009-07-27 : new version with Y
2009-07-30 : linked to instructions.html
2009-08-16 : extended forms
2009-08-23 : removed FORM_X, off-by-one in form2html
2011-09-17 : added IMM20

The "form" of an instruction describes the list and type of fields that follow the opcode.
 note : 'forms' are represented as bitfields, so their individual values are powers of 2.

Dependency : none
*/

var Y={ // declare the Y object
  TableForm:[],
  TableFormFunction:[],
  MAX_FORM:1,

  newForm:function(name, f) {
    Y[name]=Y.MAX_FORM;
    Y.TableForm[Y.MAX_FORM]=name;
    Y.TableFormFunction[Y.MAX_FORM]=f;
    Y.MAX_FORM+=Y.MAX_FORM;
  },

  random_register:function(r1,r2){
    var c;
    do
      c=Y.registers_names[Math.floor(Math.random()*16)];
    while((c==r1)||(c==r2)); // lazy and slow algorithm
    return c;    
  },

  random_Imm4:function(){
    return Math.floor(Math.random()*7)+1;
  },

  random_Imm16:function(f){
    if (f & Y.IMM20)
      return 256+Math.floor(Math.random()*(524288-256));
    if (f & Y.IMM16_5LSB)
      return Math.floor(Math.random()*16)+16
    if (f & Y.IMM16_8LSB)
      return 32+Math.floor(Math.random()*(256-32))
    return  256+Math.floor(Math.random()*(32768-256));
  }
};



// No immediate :
Y.newForm("FORM_ALONE",
  function(){return ""}
);

Y.newForm("FORM_R",
  function(){return Y.random_register()}
); // alias for some FORM_RR

Y.newForm("FORM_RR",
  function(){
    var a=Y.random_register();
    return a+" "+Y.random_register(a)
  }
);
Y.FORMS_R= Y.FORM_ALONE | Y.FORM_R | Y.FORM_RR;



// Short immediate :
Y.newForm("FORM_i",
  function(){ return Y.random_Imm4()}
);

Y.newForm("FORM_iR",
  function(){ return Y.random_Imm4()+" "+Y.random_register()}
);

Y.newForm("FORM_Ri",
  function(){ return Y.random_register()+" "+Y.random_Imm4()}
); // PUT
Y.FORMS_i = Y.FORM_i|Y.FORM_iR|Y.FORM_Ri;



// Long immediate :
Y.newForm("FORM_IRR",
  function(f){
    var a=Y.random_register();
    return Y.random_Imm16(f)+" "+a+" "+Y.random_register(a)
  }
);

Y.newForm("FORM_IR",
  function(f){ return Y.random_Imm16(f)+" "+Y.random_register()}
); // for SB, also alias for some FORM_IRR

Y.newForm("FORM_RI",
  function(f){ return Y.random_register()+" "+Y.random_Imm16(f)}
); // PUT

Y.FORMS_I = Y.FORM_IRR|Y.FORM_IR|Y.FORM_RI;



// extended forms
Y.newForm("FORM_RRR",
  function(){
    var a=Y.random_register();
    var b=Y.random_register(a);
    return a+" "+b+" "+Y.random_register(a,b);
  }
);

Y.newForm("FORM_iRR",
  function(){
    var a=Y.random_register();
    return Y.random_Imm4()+" "+a+" "+Y.random_register(a);
  }
);
Y.FORMS_EXTENDED = Y.FORM_RRR | Y.FORM_iRR;

Y.FORMS_EXTENDABLE = Y.FORMS_EXTENDED | Y.FORMS_i | Y.FORMS_R;
// not extendable : Y.FORMS_I


Y.form2html=function(form,t,n){
  var j=1, k, a='';
  if (!n)
    n=0; // set n to -32 to avoid carriage returns, forget it in the opcode map.

  do {
    if (form & j) {
      k=Y.TableForm[j];
      k=k.replace(/FORM_/,'');

      n++; // manage 
      if((n>3)&&(t==1)) {
        a+=',<br>';
        n=1;
      }
      else
        if(n>1)
          a+=',';

      a+='<a class="innerLink" onclick="winman.innerLink(\'doc/forms#'+k+'\')" href="#!ISM/'+k+'">'+k+'</a>';
    }
    j<<=1;
  } while (j<=form);

  return a;
}
