/*
  yasep/tool/test_opcodes.js created by whygee at f-cpu.org
  created 2007-04-01 from opcode_map.html
  version 2007-04-04 : moved all the JS stuff to vspsim/test/test_opcodes.js
  version 2007-04-08 : aliases included and converted
  version 2007-04-09 : some more cleanup
  version 2007-04-11 : added various details.
  version 2007-04-17 : updated for new flags
  version 2007-11-05 : YASEP rebranding, support of the flags IMM16_5LSB and IMM16_8LSB
  version 2009-07-10 : adapted for js_list2
  version 2009-07-28 : Y
  version 2009-08-10 : new disassembler
  version 2009-08-23 : it's working again !
  version 2011-09-08 : moved from benches/test_opcodes.html and turned into an autonomous window.
  version 2011-09-11 : big changes !

  This file exercises the assembler and disassembler and searches inconsistencies
*/

test_opcodes={
  win:null,
  chunks:8, // how many instructions before a page redraw
  HTML:"",
  // start creates other variables

  add_message: function(col,msg){
    test_opcodes.HTML +='      <span style="background-color:'+col+'">'+(test_opcodes.msg_number++)+'</span>: '+msg+'\n';
  },

  test_opcode: function(x) {
    test_opcodes.HTML+='  <a class="asm_active" onclick="winman.innerLink(\'tool/asm#'+x+'\')" href="#!tool/asm#'+x+'">'+x+'</a>\n';
    if (Yasep_ASM.encode_YASEP_instruction(x,test_opcodes.ASM)) {
      Yasep_DISASM(test_opcodes.ASM.encoded_instruction,test_opcodes.DISASM);
      if (test_opcodes.DISASM.instruction != x) {
        // putting the <a> tag here should force the browser to go to the first error in the list
        test_opcodes.add_message('red',' <a id="end" name="end"> output != input</a>');
        test_opcodes.errnum++;
      }
    }
    else {
      test_opcodes.add_message('red',' <a id="end" name="end"> error </a>');
      test_opcodes.errnum++;
    }
  },

  scan_opcode_table: function() {
    if (test_opcodes.cur_opcode>=test_opcodes.max_opcode) { // last opcode scanned ?
      if (test_opcodes.errnum > 0) {
        test_opcodes.win.shortmsg('Test completed with '+test_opcodes.errnum+' errors.');
//        document.getElementById("end").focus(); marche pas ?
        ygwm.changeTheme(test_opcodes.win, "doc_red")
      }
      else {
        test_opcodes.win.shortmsg('OK : Test succeeded');
        ygwm.changeTheme(test_opcodes.win, "doc_gryl")
      }
    }
    else {
      test_opcodes.HTML="";
      var chunk=test_opcodes.chunks; // display "chunks" <pre> at a time
      while ((chunk > 0) && (test_opcodes.cur_opcode<test_opcodes.max_opcode)) {
        chunk--;

        var name=test_opcodes.sorted_opcodes[test_opcodes.cur_opcode++]; // also gets rid of aliases
        var index=Y.table_opcode[name].value;
        var instr=Y.opcode_table[index];

        test_opcodes.HTML+='<hr>'+int2hex(index)+' : <a href="ISM/'+name+'.html">'
               +name+'</a>    "<i>'+instr.description+'"</i>\n';

        // Scan the forms list
        var f=instr.forms;
        var i=1;

        do {
          if (f & i) {
            var j=Y.TableForm[i];
            var k=j.replace(/FORM_/,'');
            var v=' -<a href="#docs/instructions.html#'+k+'">'+j+'</a>';

            var w=Y.TableFormFunction[i](instr.flags); // random operands
            if (w=='') // no operands so don't add a spacer that will bork the instruction
              w=instr.name;
            else 
              w=instr.name+" "+w;
            test_opcodes.HTML+=v+'\n';

            test_opcodes.test_opcode(w);

            if ((i & Y.FORMS_EXTENDABLE)&&((instr.flags & Y.NO_CONDITION)==0))
              test_opcodes.test_opcode(w+' '+Y.randomCondition());
          }
          i<<=1;
        } while (i <= f);
      } // while chunk>0...
      var new_pre = document.createElement('pre');
      new_pre.innerHTML=test_opcodes.HTML;
      test_opcodes.win.contents_id.firstChild.appendChild(new_pre);

      setTimeout(test_opcodes.scan_opcode_table,5);
    }
  },

  start: function() {
    // (re-)initialise important variables
    test_opcodes.msg_number=0;
    test_opcodes.errnum=0;
    test_opcodes.sorted_opcodes=[];
    test_opcodes.max_opcode=0;
    test_opcodes.cur_opcode=0;

    test_opcodes.win= ygwm.new_window( "", null, "none",
       650, Math.ceil((getHeight()*3)/4),
       100, 50, false, true, true, true, false);

    test_opcodes.win.contents_id.firstChild.innerHTML=import_htmi("tool/test_opcodes");
    winman.patchInnerLinks(test_opcodes.win.contents_id);
    var h=getByClass("hiddenDiv","DIV", test_opcodes.win.contents_id);
    ygwm.changeWinTitle(test_opcodes.win, hiddenText(0,h));

    test_opcodes.ASM   = new    ASM_context(test_opcodes.add_message);
    test_opcodes.DISASM= new DISASM_context(test_opcodes.add_message);

    // prepare the sorted list of opcodes
    for (var name in Y.table_opcode) {
      if ((Y.table_opcode[name].forms>0)
      && (typeof Y.opcode_aliases[name]) == "undefined") // check it's not an alias
        test_opcodes.sorted_opcodes[test_opcodes.max_opcode++]=name;
    }
    test_opcodes.sorted_opcodes=test_opcodes.sorted_opcodes.sort();
    test_opcodes.win.shortmsg('running...');
    setTimeout(test_opcodes.scan_opcode_table,50);

    return test_opcodes.win;
  },

  init_obj: function() {
    test_opcodes.menuItem = menu.subMenuItem(menu.mainMenuItem("Tools"), "Opcodes autotest", "tool/test_opcodes");
  }
};

winman.register_window("tool/test_opcodes",test_opcodes.start);
